<!DOCTYPE html>
<html lang="en">
	<head>
		<title>Bootstrap Example</title>
		<meta charset="utf-8" />
		<meta name="viewport" content="width=device-width, initial-scale=1" />
		<link
			rel="stylesheet"
			href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
		/>
		<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
		<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

		<!-- Import Datatable sau jquery -->
		<!-- Import them style bootstrap cho datatable -->
		<link
			rel="stylesheet"
			href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
		/>
		<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
		<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
	</head>
	<body>
		<div class="container">
			<h2 style="text-align: center">Danh sách người dùng</h2>

			<table
				id="user-table"
				class="table table-bordered table-striped table-hover"
			>
				<thead>
					<tr>
						<th>Mã người dùng</th>
						<th>Firstname</th>
						<th>Lastname</th>
						<th>Country</th>
						<th>Subject</th>
						<th>Customer Type</th>
						<th>Register Sttus</th>
						<th>Action</th>
					</tr>
				</thead>
				<tbody></tbody>
			</table>
		</div>
		​
		<script>
			$(document).ready(function () {
				/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
				let gUsersArr = [];

				var gNameCol = [
					'id',
					'firstname',
					'lastname',
					'country',
					'subject',
					'customerType',
					'registerStatus',
					'action',
				];
				/*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
				onPageLoading();

				$(document).on('click', '#user-table .btn-detail', function () {
					onBtnDetailClick(this);
				});

				/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
				function onPageLoading() {
					// goi api
					$.ajax({
						url: 'http://203.171.20.210:8080/devcamp-register-java-api/users',
						type: 'GET',
						dataType: 'json',
						async: false,
						success: function (paramObjectUser) {
							gUsersArr = paramObjectUser;
						},
					});
					/* Hãy đổ dữ liệu vào table và thực hiện nút information (chi tiết)
					 * dùng cách khai báo data source ngay từ đầu */
					$('#user-table').DataTable({
						data: gUsersArr,
						columns: [
							{ data: gNameCol[0] },
							{ data: gNameCol[1] },
							{ data: gNameCol[2] },
							{ data: gNameCol[3] },
							{ data: gNameCol[4] },
							{ data: gNameCol[5] },
							{ data: gNameCol[6] },
							{ data: gNameCol[7] },
						],
						columnDefs: [
							{
								targets: 7,
								className: 'text-center',
								defaultContent:
									"<button class = 'btn btn-primary btn-detail'> Chi tiết </button>",
							},
						],
					});
				}
				function onBtnDetailClick(paramElement) {
					'use strict';
					var vRowClick = $(paramElement).closest('tr');
					var vTable = $('#user-table').DataTable();
					var vDataRow = vTable.row(vRowClick).data();
					console.log(vDataRow);
				}
				/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
			});
		</script>
	</body>
</html>
​
